; +++++ Manual SubClassing Example +++++

__UNICODE__ equ 1
.586
.model flat,stdcall
option  casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD
LVProc  PROTO   :DWORD,:DWORD,:DWORD,:DWORD


include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\comctl32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\comctl32.lib

include \masm32\macros\macros.asm

.const  
MainWindowWidth     equ     600
MainWindowHeight    equ     400

.data
hInstance       HINSTANCE       ?
hMainWindow     HWND            ?
UCSTR           MainWindowClass, "MainWindowClass",0
UCSTR           MainWindowName,  "Standard Window",0
wcex            WNDCLASSEX      <sizeof wcex,CS_HREDRAW+CS_VREDRAW,offset WndProc,\
                                0,0,?,?,?,COLOR_WINDOW,0,offset MainWindowClass,?>
                                
UCSTR           ListViewClass,"SysListView32",0
UCSTR           MyListViewClass,"MyListView32",0
hListView       HWND            ?
iccx            INITCOMMONCONTROLSEX    <sizeof iccx,ICC_LISTVIEW_CLASSES>                                
wclvnew         WNDCLASS        <>
lpDefLVProc     DD              ?
rect            RECT            <>
UCSTR           szAttention,"Attention",0
UCSTR           szCreated,"WM_CREATE",0
.code
    start:
        invoke  GetModuleHandle,NULL
        mov     hInstance,eax
        invoke  WinMain,hInstance,0,0,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInst
    pop     wcex.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wcex.hIcon,eax
    mov     wcex.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wcex.hCursor,eax
    invoke  RegisterClassEx,addr wcex
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_OVERLAPPEDWINDOW,\
                eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,SW_SHOWNORMAL
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop                        
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    .if     uMsg==WM_CREATE
        mov     edi,lParam
        .if     [edi.CREATESTRUCT].hWndParent==0
            invoke  GetClassInfo,hInstance,addr ListViewClass,addr wclvnew
            push    wclvnew.lpfnWndProc
            pop     lpDefLVProc               
            mov     wclvnew.lpfnWndProc,offset LVProc
            mov     wclvnew.lpszClassName,offset MyListViewClass
            invoke  RegisterClass,addr wclvnew
            invoke  GetClientRect,hWnd,addr rect
            invoke  CreateWindowEx,0,addr MyListViewClass,0,WS_VISIBLE+WS_CHILD+LVS_REPORT,
                        0,0,rect.right,rect.bottom,hWnd,0,hInstance,0
            mov     hListView,eax                        
        .endif
    .elseif uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor     eax,eax
    ret

WndProc     endp                                                

LVProc  PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    .if     uMsg==WM_CREATE
        invoke  MessageBox,hWnd,addr szCreated,addr szAttention,MB_OK
    .endif
    invoke  CallWindowProc,lpDefLVProc,hWnd,uMsg,wParam,lParam
    ret
    
LVProc  endp
end     start